SystemOrganization addCategory: #'TADP-AddTraitRefactor'!
SystemOrganization addCategory: #'TADP-AddTraitRefactor-Fixture'!
SystemOrganization addCategory: #'TADP-Metaprogramacion'!
SystemOrganization addCategory: #'TADP-Metaprogramacion-Fixture'!

Trait named: #Ladrador
	uses: {}
	category: 'TADP-AddTraitRefactor-Fixture'!

!Ladrador methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/2/2013 23:06'!
altura
	^100! !

!Ladrador methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/2/2013 23:05'!
ladrar
	self hambre: self hambre + 6! !

Trait named: #MuyAlto
	uses: {}
	category: 'TADP-AddTraitRefactor-Fixture'!

!MuyAlto methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/2/2013 23:06'!
altura
	^999! !

Object subclass: #AddTraitRefactor
	instanceVariableNames: 'refactorClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-AddTraitRefactor'!

!AddTraitRefactor class methodsFor: 'Constructors' stamp: 'RodrigoAlfonso 5/2/2013 22:24'!
for: refactorClass
	^(self new)
		refactorClass: refactorClass;
		yourself.! !

!AddTraitRefactor methodsFor: 'Refactor methods' stamp: 'RodrigoAlfonso 5/2/2013 22:29'!
"Agrega un trait a la clase"
addTrait: trait
| oldTraitComposition oldInstVars |
	"Datos anteriores:"
	oldTraitComposition:= refactorClass traitComposition.
	oldInstVars:= refactorClass instVarNames.
	
	"Redefinir clase:"
	refactorClass superclass
		subclass: refactorClass name
		uses: oldTraitComposition + trait
		instanceVariableNames:  ''
		classVariableNames:  ''
		poolDictionaries:  (refactorClass poolDictionaryNames joinUsing: ' ')
		category: refactorClass category.
		
	"Copiar variables de instancia:"
	oldInstVars do: [ :attributeName | refactorClass addInstVarNamed:  attributeName ].! !

!AddTraitRefactor methodsFor: 'Refactor methods' stamp: 'RodrigoAlfonso 5/3/2013 22:13'!
"Agrega un trait a la clase y resuelve los conflictos con la estrategia especificada"
addTrait: trait andResolveWith: strategy
| allTraits conflictingMethods conflictingTraits |
	allTraits:= self getAllTraits.
	allTraits add: trait.
	
	conflictingMethods:= self getConflictingMethodsFor: allTraits.
	conflictingTraits:= self getConflictingTraitsIn: allTraits for: conflictingMethods.

	"Por cada mtodo delegar a la estrategia la implementacin:"
	conflictingMethods do: [:method | 
		strategy resolve: method
				  between: (conflictingTraits select: [:t | t selectors includes: method])
				  for: refactorClass.
	].

	self addTrait: trait.! !

!AddTraitRefactor methodsFor: 'Refactor methods' stamp: 'RodrigoAlfonso 5/3/2013 22:19'!
"Obtiene todos los traits de la clase"
getAllTraits
	^self refactorClass traitComposition transformations copy! !

!AddTraitRefactor methodsFor: 'Refactor methods' stamp: 'RodrigoAlfonso 5/3/2013 22:09'!
"Devuelve los mtodos que estn en conflicto"
getConflictingMethodsFor: traits
| repeatedMethods |
	repeatedMethods:= self getRepeatedMethodsFor: traits.
	
	"Los conflictivos sern los repetidos que no estn definidos en la clase:"
	^repeatedMethods reject:
		[:method | (refactorClass traitThatOriginated: (refactorClass >> method)) isNil]! !

!AddTraitRefactor methodsFor: 'Refactor methods' stamp: 'RodrigoAlfonso 5/3/2013 22:10'!
"Devuelve los traits que entienden alguno de los mtodos conflictivos"
getConflictingTraitsIn: traits for: conflictingMethods
	^traits reject: [:trait | (trait selectors intersection: conflictingMethods) isEmpty]! !

!AddTraitRefactor methodsFor: 'Helpers' stamp: 'RodrigoAlfonso 5/3/2013 22:04'!
"Devuelve los mtodos repetidos de una coleccin de traits"
getRepeatedMethodsFor: traits
	traits size < 2 ifTrue: [
		^Set new.
	].

	^traits inject: (traits first selectors)
			   into: [:conflictingMethods :trait | conflictingMethods intersection: trait selectors].! !

!AddTraitRefactor methodsFor: 'Accessing' stamp: 'RodrigoAlfonso 5/2/2013 22:21'!
refactorClass
	^ refactorClass! !

!AddTraitRefactor methodsFor: 'Accessing' stamp: 'RodrigoAlfonso 5/2/2013 22:30'!
refactorClass: anObject
	refactorClass := anObject! !

Object subclass: #ConflictStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-AddTraitRefactor'!

ConflictStrategy subclass: #BlockConflictStrategy
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-AddTraitRefactor'!

BlockConflictStrategy subclass: #ApplyConflictStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-AddTraitRefactor'!

!ApplyConflictStrategy methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 00:56'!
resolve: conflictingMethod between: conflictingTraits for: conflictingClass
| newSource |
	newSource:= self mergeOf: conflictingMethod between: conflictingTraits for: conflictingClass.
	
	newSource:= newSource, self getReturn, self block asString, ' value: results'.
	
	conflictingClass compile: newSource.! !

!BlockConflictStrategy class methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 00:50'!
withBlock: block
	^(self new) block: block; yourself! !

!BlockConflictStrategy methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 00:41'!
block
	^block! !

!BlockConflictStrategy methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 00:41'!
block: anObject
	block:= anObject! !

!BlockConflictStrategy methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 00:58'!
getHeaderFor: conflictingMethod
	^conflictingMethod asString, '
| results |
	results:= OrderedCollection new.
	'.! !

!BlockConflictStrategy methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 00:54'!
mergeOf: conflictingMethod between: conflictingTraits for: conflictingClass
| newSource |
	newSource:= self getHeaderFor: conflictingMethod.
	
	conflictingTraits do:
		[:trait | conflictingClass compile: '_', trait name, ((trait >> conflictingMethod) sourceCode)].
	
	conflictingTraits do: [:trait |
		newSource:= newSource,
					   self getNewLine,
					   'results add: (self _',
					   (trait name, (conflictingClass >> conflictingMethod) selector asString), 
					   '). '
	].
	
	^newSource! !

BlockConflictStrategy subclass: #ConditionConflictStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-AddTraitRefactor'!

!ConditionConflictStrategy methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 00:46'!
resolve: conflictingMethod between: conflictingTraits for: conflictingClass
| newSource |
	newSource:= self mergeOf: conflictingMethod between: conflictingTraits for: conflictingClass.
	
	newSource:= newSource,
				   self getReturn,
				   'results detect: ', self block asString, ' ifNone: [self error]'.
	
	conflictingClass compile: newSource.! !

ConflictStrategy subclass: #CallConflictStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-AddTraitRefactor'!

!CallConflictStrategy methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 00:25'!
resolve: conflictingMethod between: conflictingTraits for: conflictingClass
| newSource |
	newSource:= self getHeaderFor: conflictingMethod.
	
	conflictingTraits do:
		[:trait | conflictingClass compile: '_', trait name, ((trait >> conflictingMethod) sourceCode)].
	
	conflictingTraits do: [:trait |
			newSource:= newSource, 
						   'self _',
						   (trait name, (conflictingClass >> conflictingMethod) selector asString),
						   '. '
		].
	
	conflictingClass compile: newSource.! !

!ConflictStrategy methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 00:21'!
getHeaderFor: conflictingMethod
	^conflictingMethod asString, '
	'! !

!ConflictStrategy methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 00:55'!
getNewLine
	^'
	'! !

!ConflictStrategy methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 00:51'!
getReturn
	^'
	
	^'! !

ConflictStrategy subclass: #KeepFirstConflictStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-AddTraitRefactor'!

!KeepFirstConflictStrategy methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/3/2013 03:19'!
"Resuelve el conflicto"
resolve: conflictingMethod between: conflictingTraits for: conflictingClass
	conflictingClass compile: (conflictingTraits first sourceCodeAt: conflictingMethod)! !

Object subclass: #Perrito
	instanceVariableNames: 'hambre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-AddTraitRefactor-Fixture'!

Perrito class
	instanceVariableNames: 'hambreGlobalPerruna'!

Perrito class
	instanceVariableNames: 'hambreGlobalPerruna'!

!Perrito methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/2/2013 23:10'!
caminar
	self hambre: self hambre + 2! !

!Perrito methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/2/2013 23:10'!
comer
	self hambre: self hambre - 10
	! !

!Perrito methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/2/2013 23:10'!
estaEnojado
	^ self hambre > 20! !

!Perrito methodsFor: 'accessing' stamp: 'RodrigoAlfonso 5/2/2013 23:10'!
hambre
	^ hambre! !

!Perrito methodsFor: 'accessing' stamp: 'RodrigoAlfonso 5/2/2013 23:10'!
hambre: anObject
	hambre := anObject! !

Object subclass: #Perro
	instanceVariableNames: 'hambre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Metaprogramacion-Fixture'!

Perro class
	instanceVariableNames: 'hambreGlobalPerruna'!

Perro class
	instanceVariableNames: 'hambreGlobalPerruna'!

!Perro methodsFor: 'as yet unclassified' stamp: 'Demian 4/27/2013 10:32'!
caminar
	self hambre: self hambre + 2! !

!Perro methodsFor: 'as yet unclassified' stamp: 'Demian 4/27/2013 10:31'!
comer
	self hambre: self hambre - 10
	! !

!Perro methodsFor: 'as yet unclassified' stamp: 'Demian 4/27/2013 10:32'!
estaEnojado
	^ self hambre > 20! !

!Perro methodsFor: 'accessing' stamp: 'Demian 4/27/2013 10:31'!
hambre
	^ hambre! !

!Perro methodsFor: 'accessing' stamp: 'Demian 4/27/2013 10:31'!
hambre: anObject
	hambre := anObject! !

Object subclass: #SimpleExtractSuperclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Metaprogramacion'!

!SimpleExtractSuperclass class methodsFor: 'as yet unclassified' stamp: 'Demian 4/28/2013 12:29'!
from: target to: superclassName

	| newSuperclass |
	newSuperclass  := target superclass
		subclass: superclassName 
		 instanceVariableNames:  ''
		classVariableNames:  ''
		poolDictionaries:  (target poolDictionaryNames joinUsing: ' ')
		category:  target category.
	

	target instVarNames do: [ :attributeName | newSuperclass addInstVarNamed:  attributeName ].
	
	target selectors do: [ :selector | 
		newSuperclass compile: (target >> selector) sourceCode. 
		target removeSelector: selector. 
	].

	target superclass: newSuperclass.

	target instVarNames do: [ :attributeName | target removeInstVarNamed: attributeName ].	
! !

TestCase subclass: #AddTraitRefactorTestCase
	instanceVariableNames: 'refactor perritoClass ladradorTrait muyAltoTrait'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-AddTraitRefactor'!

!AddTraitRefactorTestCase methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 01:06'!
setUp
	"Los mtodos en conflicto no pueden aceptar parmetros"
	MetaUtil recreateCategory: 'TADP-AddTraitRefactor-Fixture'.

	perritoClass:= Smalltalk at: #Perrito.
	refactor:= AddTraitRefactor for: perritoClass.
	
	ladradorTrait := Smalltalk at: #Ladrador.
	muyAltoTrait := Smalltalk at: #MuyAlto.! !

!AddTraitRefactorTestCase methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 00:07'!
tearDown
	self setUp! !

!AddTraitRefactorTestCase methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 01:06'!
testAgregarTraitAPerritoNoPierdeVariablesDeInstancia
	refactor addTrait: ladradorTrait.
	
	self assert: perritoClass instVarNames includes: #hambre.! !

!AddTraitRefactorTestCase methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 01:06'!
testAgregarTraitLadradorAPerritoHaceQueSepaLadrar
	refactor addTrait: ladradorTrait.
	
	self assert: (perritoClass selectors includes: #ladrar)! !

!AddTraitRefactorTestCase methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 01:08'!
testCaminarNoEsUnConflictoYaQueClaseMataTrait
	refactor addTrait: ladradorTrait.
	refactor addTrait: muyAltoTrait.
	
	self assert: (
		(
			(refactor getConflictingMethodsFor: (refactor getAllTraits)) includes: #caminar
		) not
	)! !

!AddTraitRefactorTestCase methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 01:06'!
testListarTraitsLuegoDeAgregarUnPar
	refactor addTrait: ladradorTrait.
	refactor addTrait: muyAltoTrait.
	
	self assert: (refactor getAllTraits includes: ladradorTrait).
	self assert: (refactor getAllTraits includes: muyAltoTrait).! !

!AddTraitRefactorTestCase methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 01:10'!
testObtenerMetodosRepetidosEntreTraitsLadradorYMuyAlto
	refactor addTrait: ladradorTrait.
	refactor addTrait: muyAltoTrait.
	
	self assert: (
		refactor getRepeatedMethodsFor: (refactor getAllTraits)
	)! !

!AddTraitRefactorTestCase methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 01:16'!
testWorkspace_ApplyConflictStrategy
	MetaUtil recreateCategory: 'TADP-AddTraitRefactor-Fixture'.
	
	perritoClass:= Smalltalk at: #Perrito.
	refactor:= AddTraitRefactor for: perritoClass.
	
	ladradorTrait := Smalltalk at: #Ladrador.
	muyAltoTrait := Smalltalk at: #MuyAlto.
	
	refactor addTrait: ladradorTrait andResolveWith: (ApplyConflictStrategy withBlock: [:aItem | aItem sum]).
	refactor addTrait: muyAltoTrait andResolveWith: (ApplyConflictStrategy withBlock: [:aItem | aItem sum]).! !

!AddTraitRefactorTestCase methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 01:15'!
testWorkspace_CallConflictStrategy
	MetaUtil recreateCategory: 'TADP-AddTraitRefactor-Fixture'.
	
	perritoClass:= Smalltalk at: #Perrito.
	refactor:= AddTraitRefactor for: perritoClass.
	
	ladradorTrait := Smalltalk at: #Ladrador.
	muyAltoTrait := Smalltalk at: #MuyAlto.
	
	refactor addTrait: ladradorTrait andResolveWith: (CallConflictStrategy new).
	refactor addTrait: muyAltoTrait andResolveWith: (CallConflictStrategy new).! !

!AddTraitRefactorTestCase methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 01:16'!
testWorkspace_ConditionConflictStrategy
	MetaUtil recreateCategory: 'TADP-AddTraitRefactor-Fixture'.
	
	perritoClass:= Smalltalk at: #Perrito.
	refactor:= AddTraitRefactor for: perritoClass.
	
	ladradorTrait := Smalltalk at: #Ladrador.
	muyAltoTrait := Smalltalk at: #MuyAlto.
	
	refactor addTrait: ladradorTrait andResolveWith: (ConditionConflictStrategy withBlock: [:aItem | aItem > 50]).
	refactor addTrait: muyAltoTrait andResolveWith: (ConditionConflictStrategy withBlock: [:aItem | aItem > 50]).! !

!AddTraitRefactorTestCase methodsFor: 'as yet unclassified' stamp: 'RodrigoAlfonso 5/4/2013 01:15'!
testWorkspace_KeepFirstConflictStrategy
	MetaUtil recreateCategory: 'TADP-AddTraitRefactor-Fixture'.
	
	perritoClass:= Smalltalk at: #Perrito.
	refactor:= AddTraitRefactor for: perritoClass.
	
	ladradorTrait := Smalltalk at: #Ladrador.
	muyAltoTrait := Smalltalk at: #MuyAlto.
	
	refactor addTrait: ladradorTrait andResolveWith: (KeepFirstConflictStrategy new).
	refactor addTrait: muyAltoTrait andResolveWith: (KeepFirstConflictStrategy new).! !

TestCase subclass: #ExtractSuperclassTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Metaprogramacion'!

!ExtractSuperclassTestCase methodsFor: 'as yet unclassified' stamp: 'Demian 4/27/2013 10:38'!
setUp
	MetaUtil recreateCategory: 'TADP-Metaprogramacion-Fixture'! !

!ExtractSuperclassTestCase methodsFor: 'as yet unclassified' stamp: 'Demian 4/28/2013 12:30'!
testExtraerAnimalDePerro
	| animalClass perroClass|
	
	perroClass := Smalltalk at: #Perro.

	SimpleExtractSuperclass from: perroClass to: #Animal.
	
	animalClass := Smalltalk at: #Animal.
	
	self assert: (animalClass instVarNames includes: 'hambre').
	
	self assert: 'comer
	self hambre: self hambre - 10
	
	'
		equals: (animalClass >> #comer) sourceCode 
	.
	
	self assert: animalClass equals: (perroClass superclass).
	self assert: perroClass selectors isEmpty.
	self assert: perroClass instVarNames isEmpty.! !
